#!/bin/bash

# Version 23/12/2011
# $Revision: 1.6 $
# UDA'Software 2010

# Questo script serve per la gestione dei LOGs di XChat.

log_file_path="${HOME}/.xchat2/xchatlogs"
time_lag=3600
archive_max_size=16M

autobackup_log_file=$HOME/.xchat2/buduscript/autobackup_log_file.lck

if [ ! -d ${log_file_path} ]; then
    echo "/ECHO %C4,1ERRORE GRAVE: Directory dei LOG non trovata (${log_file_path})."
    echo "/ECHO %C3,1E' necessario abilitare i LOG in XChat per utilizzare questo script."
    
    exit 1;
fi

# ##############################################################################
################################################################################
# FUNZIONI
################################################################################
list_log() {
    if [ "${list_log_files}" != "" ]; then
	{
	    printf "Premi 'q' per Uscire (Quit); i tasti freccia o pagina SU e GIU per spostarti.\n"
	    printf "%57s [%8s ] [%s]\n" "Nome File Log" "Dimens." "Data    "
	    printf "${list_log_files}\n"
	} | less
    else
	printf "ATTENZIONE: Non sono presenti files log da elencare.\n"
	printf "********************************************************************************\n"
	printf "Premi INVIO per continuare.\n"
	read
    fi
}

view_log() {
    if [ "${list_log_files}" != "" ]; then
	printf "********************************************************************************\n"
	printf "Seleziona il numero corrispondente al LOG che vuoi visionare e premi INVIO.\n"
	
	select log_file in ${list_log_files}; do
	    {
		printf "Premi 'q' per Uscire (Quit); i tasti freccia o pagina SU e GIU per spostarti.\n"
		printf "Premi '/' seguito dalla parola che vuoi cercare e premi invio. Per cercare\n"
		printf "ancora premi il tasto 'n' (Next, successivo) o 'p' (Previous, precedente).\n"
		printf "********************************************************************************\n"
		${1}cat -n ${log_file_path}/${log_file} | sed s/[^[:print:]]/\ /g
	    } | less
	    break;
	done
    else
	printf "ATTENZIONE: Il file log non e' stato trovato, forse e' stato cancellato ?.\n"
	printf "********************************************************************************\n"
	printf "Premi INVIO per continuare.\n"
    read
    fi
}

archive_log() {
    if [ "${list_log_files}" != "" ]; then
	printf "********************************************************************************\n"
	printf "Seleziona il numero corrispondente al LOG che vuoi archiviare e premi INVIO.\n"
	
	select log_file in ${list_log_files}; do
	    if [ -f ${log_file_path}/${log_file} ]; then
		log_file_renamed=${log_file/.log/_$(date +%Y%m%d%H%M%S).log}
		mv  "${log_file_path}/${log_file}" "${log_file_path}/${log_file_renamed}"
		gzip "${log_file_path}/${log_file_renamed}"
		printf "********************************************************************************\n"
		printf ""
		ls "${log_file_path}/${log_file_renamed}.gz"
		printf "********************************************************************************\n"
		printf "Premi INVIO per continuare.\n"
		read
	    else
		printf "ATTENZIONE: Non hai fatto una selezione valida, devo abortire.\n"
		printf "********************************************************************************\n"
		printf "Premi INVIO per continuare.\n"
		read
	    fi
	    break;
	done
    else
	printf "ATTENZIONE: Il file log non e' stato trovato, forse e' stato cancellato ?.\n"
	printf "********************************************************************************\n"
	printf "Premi INVIO per continuare.\n"
	read
    fi
}

archive_logs() {
    if [ "${list_log_files}" != "" ]; then
	for log_file in ${list_log_files}; do
	    if [ -f ${log_file_path}/${log_file} ]; then
		log_file_renamed=${log_file/.log/_$(date +%Y%m%d%H%M%S).log}
		mv  "${log_file_path}/${log_file}" "${log_file_path}/${log_file_renamed}"
		gzip "${log_file_path}/${log_file_renamed}"
		if [ "${1}" != "no_input" ]; then
		    printf "********************************************************************************\n"
		    printf ""
		    ls "${log_file_path}/${log_file_renamed}.gz"
		else
		    printf "/ECHO %%C3,1XChat LOG Archived:%%C6,1 ${log_file_renamed}\n"
		fi
	    fi
	done
	
	if [ "${1}" != "no_input" ]; then
	    printf "********************************************************************************\n"
	    printf "Premi INVIO per continuare.\n"
	    read
	fi
    fi
}

delete_log() {
    list_log_files=$(find ${log_file_path} -name "*.${1}" -printf "%f\n")
    printf "********************************************************************************\n"
    printf "Seleziona il numero corrispondente al LOG che vuoi ELIMINARE e premi INVIO.\n"
    
    exit_remove=0
    while [ ${exit_remove} == 0 ] && [ "${list_log_files}" != "" ]; do
	select log_file in "Esci" ${list_log_files}; do
	    if [ "${log_file}" == "Esci" ]; then
		exit_remove=1
		break;
	    else
		rm -fiv ${log_file_path}/${log_file}
	    fi
	    break;
	done
	list_log_files=$(find ${log_file_path} -name "*.${1}" -printf "%f\n")
	clear
	printf "********************************************************************************\n"
	printf "Seleziona il numero corrispondente al LOG che vuoi ELIMINARE e premi INVIO.\n"
    done
    if [ "${list_log_files}" == "" ]; then
	printf "ATTENZIONE: Non sono presenti files log da ELIMINARE.\n"
	printf "********************************************************************************\n"
	printf "Premi INVIO per continuare.\n"
	read
    fi
}

# ##############################################################################
################################################################################
# MAIN
################################################################################
if [ "${1}" == "AUTORUN" ]; then
    echo "/exec xterm -e \"$HOME/.xchat2/buduscript/buduscript_script__log_manager.sh\""
    
    exit 0;
fi

if [ "${1}" == "AUTOBACKUP" ]; then
    list_log_files=$(find ${log_file_path} -name "*.log"  -size +${archive_max_size} -printf "%f\n")
    archive_logs no_input
    
    if [ "${2}" == "START" ]; then
	touch $HOME/.xchat2/buduscript/autobackup_log_file.lck
	if [ ! -f ${autobackup_log_file} ]; then
	    printf "/ECHO %%C4,1ERRORE: Impossibile avviare correttamente la procedura di autobackup dei files log\n"
	    printf "/ECHO %%C6,1E' probabilmente presente un problema a livello di permessi nella cartella ${HOME}/.xchat2/buduscript\n"
	    exit 1;
	else
	    printf "/ECHO %%C3,1Avviata procedura di auto-backup dei LOGs di XChat superiori a ${archive_max_size}\n"
	fi
    fi
    if [ -f ${autobackup_log_file} ]; then
	echo "/budus InsertCommandInQueueTimed(0) ${time_lag} budus pipe_script_silent \"$HOME/.xchat2/buduscript/buduscript_script__log_manager.sh\" AUTOBACKUP"
    fi
    
    exit 0;
fi

# ########## ########## ########## ########## ########## ########## ##########
# ########## ########## ##########   INIZIO   ########## ########## ##########
# ########## ########## ########## ########## ########## ########## ##########
IFS_OLD=${IFS}
IFS=$'\n'
COLUMNS=30
options_main="Esci dalla gestione dei LOGs
Elenca i LOGs correnti
Elenca i LOGs archiviati
Visualizza un LOG corrente
Visualizza un LOG archiviato
Archivia un LOG corrente
Archivia TUTTI i LOGs correnti
Archivia TUTTI i LOGs correnti maggiori di ${archive_max_size}b
Cerca nei LOGs correnti
Cerca in TUTTI i LOGs
Elimina un LOG corrente
Elimina TUTTI i LOGs correnti
Elimina un LOG archiviato
Elimina TUTTI i LOGs archiviati"

options=${options_main}

while [ 1 == 1 ]; do
    clear
    cat<<EOF
********************************************************************************
*                             MANAGER DEI LOGs                                 *
********************************************************************************
Questa procedura ti permette di gestire in modo semplice e rapido i LOGs
generati da XChat (per default non sono attivi, vanno abilitati tramite le
preferenze del client), come elencare quelli correnti, archiviarli, elencare
quelli archiviati, eseguire ricerche, ecc...
********************************************************************************
EOF
    printf "Digita il numero corrispondente alla scelta e premi INVIO:\n"
    select option_selected in ${options}; do
	if [ "${option_selected}" == "Elenco Utenti" ]; then
	    options=${options_list}
	elif [ "${option_selected}" == "Elenca i LOGs correnti" ]; then
	    list_log_files=$(find ${log_file_path} -name "*.log" -printf "%57f [%8kk] [%AD]\n" | sort)
	    list_log
	elif [ "${option_selected}" == "Elenca i LOGs archiviati" ]; then
	    list_log_files=$(find ${log_file_path} -name "*.log.gz" -printf "%57f [%8kk] [%AD]\n" | sort)
	    list_log
	elif [ "${option_selected}" == "Visualizza un LOG corrente" ]; then
	    list_log_files=$(find ${log_file_path} -name "*.log" -printf "%f\n")
	    view_log
	elif [ "${option_selected}" == "Visualizza un LOG archiviato" ]; then
	    list_log_files=$(find ${log_file_path} -name "*.log.gz" -printf "%f\n")
	    view_log z
	elif [ "${option_selected}" == "Archivia un LOG corrente" ]; then
	    list_log_files=$(find ${log_file_path} -name "*.log" -printf "%f\n")
	    archive_log
	elif [ "${option_selected}" == "Archivia TUTTI i LOGs correnti" ]; then
	    list_log_files=$(find ${log_file_path} -name "*.log" -printf "%f\n")
	    archive_logs
	elif [ "${option_selected}" == "Archivia TUTTI i LOGs correnti maggiori di ${archive_max_size}b" ]; then
	    list_log_files=$(find ${log_file_path} -name "*.log"  -size +${archive_max_size} -printf "%f\n")
	    archive_logs no_input
	elif [ "${option_selected}" == "Cerca nei LOGs correnti" ] || [ "${option_selected}" == "Cerca in TUTTI i LOGs" ]; then
	    echo "Inserisci la parola chiave da cercare (sono ammesse regexp del comando grep): "
	    read search_string
	    {
		printf "Premi 'n' per cercare ogni corrispondenza di:"
		printf " ${search_string}\n"
		printf "Premi 'q' per Uscire (Quit); i tasti freccia o pagina SU e GIU per spostarti.\n"
		printf "********************************************************************************\n"
		grep -i -A5 -B5 "${search_string//\ /.*}" ${log_file_path}/*.log
		if [ "${option_selected}" == "Cerca in TUTTI i LOGs" ]; then
		    zgrep -i -A5 -B5 "${search_string//\ /.*}" ${log_file_path}/*.log.gz
		fi
	    } | less +/"${search_string//\ /.*}" -I
	elif [ "${option_selected}" == "Elimina un LOG corrente" ]; then
	    delete_log log
	elif [ "${option_selected}" == "Elimina TUTTI i LOGs correnti" ]; then
	    list_log_files=$(find ${log_file_path} -name "*.log" -printf "%f\n")
	    for log_file in ${list_log_files}; do
		rm -fiv ${log_file_path}/${log_file}
	    done
	    echo "Premi INVIO per continuare."
	    read
	elif [ "${option_selected}" == "Elimina un LOG archiviato" ]; then
	    delete_log log.gz
	elif [ "${option_selected}" == "Elimina TUTTI i LOGs archiviati" ]; then
	    list_log_files=$(find ${log_file_path} -name "*.log.gz" -printf "%f\n")
	    [ "${list_log_files}" != "" ] && \
		list_log_files_number=$(echo "${list_log_files}" | wc -l)
	    
	    clear
	    cat<<EOF
********************************************************************************
*                             MANAGER DEI LOGs                                 *
********************************************************************************
ATTENZIONE: Non e' possibile annullare questa operazione.

Risultano archiviati ${list_log_files_number:-0} LOG.

Sei sicuro di voler eliminare tutti i LOGs archiviati ? (y/N)
EOF
	    read answer
	    if [ "${answer:-N}" == "y" ] || [ "${answer:-N}" == "Y" ]; then
		for log_file in ${list_log_files}; do
		    rm -fv ${log_file_path}/${log_file}
		done
		echo "Premi INVIO per continuare."
		read
	    fi
	elif [ "${option_selected}" == "Esci dalla gestione dei LOGs" ]; then
	    IFS=${IFS_OLD}
	    exit 0;
	fi
	break;
    done
done

IFS=${IFS_OLD}
